#include <cstdlib>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;
static void op(const char *c) {
    printf("%s\n", c);
}
static void num(int x ) {
    if (x<0) 
        printf("NUM %d\nINV\n", -x);
    else
        printf("NUM %d\n", x);
}

#define FRU(M) for (int i=0; i<(M); i++)

static void solve()
{
    int n; scanf("%d", &n);

	if(!n) exit(0);

    vector<int> V(n), R(n);
    for (int i=0; i<n; i++) scanf("%d %d", &V[i], &R[i]);
    if (n == 1) {
        op("POP");
        num(R[0]);
        op("END");
        printf("\n");
        return;
    }

    FRU(n-1) op("DUP");
    num(0);
    for (int i=0; i<n; i++) {
        op("SWP");  
        for (int j=0; j<n-2; j++) op("DUP");
        num(1);
        int prod=1;
        for (int k=0; k<n; k++) {
            if (k==i) continue;
            prod*=(V[i]-V[k]);
            op("SWP");
            num(V[k]);
            op("SUB");
            op("MUL");
        }
        num(R[i]);
        op("MUL");
        num(prod);
        op("DIV");
        op("ADD");
    }
    op("END");
    printf("\n");

}

int main(void) {
	for(;;) solve();
}

